# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc收货地址删除功能验证_代客下单,2295,2295-42,sit,bs
主数据平台:后台运营系统收货地址删除接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.db.db import mySql
import requests

module = "cmdc_order_list"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 数据库操作
mysql_handle = mySql()
# 获取conf.ini文件中配置的数据库信息
host, port, user, pwd = mysql_handle.getConf(db="cmdc_db")

# 查询数据库中收货地址信息
sql = "SELECT t.addressId FROM `cmdc-user`.cmdc_address t " \
      "WHERE mobile = 18700000000 and receiverName = '收货地址新增测试' and deleteSign = 0"
address_id = mysql_handle.selectSql(host, port, user, pwd, "cmdc-order", sql)[0][0]

# 第三步进行收货地址删除操作
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url43")
request_body = commonFuc().get_business_data(module, "payload43", address_id)
# print(request_body)
"""
 场景: 收货地址删除功能验证_代客下单
 用例名称：收货地址删除功能验证_代客下单
 输出：{"deleteSign":1}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 查询数据库中收货地址删除标识
sql = "SELECT t.deleteSign FROM `cmdc-user`.cmdc_address t WHERE addressId = {}".format(address_id)
result = {"deleteSign": mysql_handle.selectSql(host, port, user, pwd, "cmdc-order", sql)[0][0]}

# 将接口响应时间添加至结果中
result["api_time"] = api_time
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict43")
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
