# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc查询条件验证_采购单列表,2295,2295-7,sit,bs
主数据平台:后台运营系统获取采购单列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import random
import datetime
import requests
import json

module = "cmdc_order_list"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取采购单列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url6")
request_body = commonFuc().get_business_data(module, "payload6")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
pur_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取采购单信息
bill_no = result["data"]["list"][pur_random]["billNo"]
bill_status_list = result["data"]["list"][pur_random]["billStatus"]
creator = result["data"]["list"][pur_random]["creator"]
demand_no = ""
start_time = result["data"]["list"][pur_random]["createTime"][:10]
end_time = datetime.datetime.now().strftime("%Y-%m-%d")

# 第三步获取采购单列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url7")
request_body = commonFuc().get_business_data(module, "payload7", bill_no, bill_status_list, creator, demand_no,
                                             start_time,
                                             end_time, start_time, end_time)
# print(request_body)
"""
 场景: 查询条件验证_采购单列表
 用例名称：查询条件验证_采购单列表
 输出：{"billNo":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取采购单号
result = json.loads(result.content)
# print(result)
result = {"billNo": result["data"]["list"][0]["billNo"]}

# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict7", bill_no)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
