# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc获取用户JDE地址信息,2295,2295-102,sit,bs
主数据平台:后台运营系统获取用户JDE地址信息接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.db.db import mySql
import random
import requests
import json

module = "cmdc_order_list"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取需求单列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url_list")
request_body = commonFuc().get_business_data(module, "payload_list")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
demand_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取需求单信息
customerId = result["data"]["list"][demand_random]["customerId"]

# 第三步获取用户JDE地址信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url102")
request_body = commonFuc().get_business_data(module, "payload102", customerId)

"""

 场景: 获取用户JDE地址信息
 用例名称：获取用户JDE地址信息
 输出：{"total":"%s"}
"""

# 发送请求
result = requests.get(url, params=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取用户JDE地址信息
result = json.loads(result.content)
result = {"total": len(result["data"])}

# 将接口响应时间添加至result
result["api_time"] = api_time

# 数据库操作
mysql_handle = mySql()
# 获取conf.ini文件中配置的数据库信息
host, port, user, pwd = mysql_handle.getConf(db="cmdc_db")

# 查询数据库中用户JDE地址数量
sql = "SELECT count(t.addressId) FROM `cmdc-user`.cmdc_user_address t " \
      "WHERE userId = {} AND isJde = 0 AND companyId = 7 AND deleteSign = 0 AND isDefault = 0".format(customerId)
total = mysql_handle.selectSql(host, port, user, pwd, "cmdc-cms", sql)[0][0]

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict102", total)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
