# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc查询条件验证_库存上报列表,2294,2294-40,sit,be
主数据平台:多采商城获取库存上报列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.多采商城登录.多采商城登录 import CmdcMaiiLogin
import random
import requests
import datetime
import json

module = "cmdc_trade"

# 第一步获取登录多采商城所需账号密码
username = commonFuc().get_business_data(module, "username_be")
password = commonFuc().get_business_data(module, "password_be")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcMaiiLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers1", cmdc_access_token)

# 第二步获取库存上报列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url38")
request_body = commonFuc().get_business_data(module, "payload38")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
stock_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取库存上报信息
source = result["data"]["list"][stock_random]["source"]
statistic_year = result["data"]["list"][stock_random]["statisticYear"]
statistic_month = result["data"]["list"][stock_random]["statisticMonth"]

# 第三步进行查询条件验证
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url39")
request_body = commonFuc().get_business_data(module, "payload39", source, statistic_year, statistic_month)

"""

 场景: 查询条件验证_库存上报列表
 用例名称：查询条件验证_库存上报列表
 输出：{"source":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
# 获取查询结果中库存上报信息中source
result = json.loads(result.content)
result = {"source": result["data"]["list"][0]["source"]}

# 将接口响应时间添加至result
result["api_time"] = api_time
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict39", source)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
