# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc公司基础信息删除功能验证,2256,2256-40,sit,bs
主数据平台:后台运营系统公司基础信息删除接口 
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.db.db import mySql
import requests
import json

module = "cmdc_website"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username")
password = commonFuc().get_business_data(module, "password")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers1", cmdc_access_token)

# 第二步获取公司基础配置信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url40_1")
request_body = commonFuc().get_business_data(module, "payload40_1")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 获取公司配置信息
configId = result["data"]["list"][0]["configId"]

# 第三步公司基础信息删除操作
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url40")
request_body = commonFuc().get_business_data(module, "payload40", configId)

"""
 场景: 公司基础信息删除功能验证
 用例名称：公司基础信息删除功能验证
 输出：{"deleteSign":1}
"""

# 发送请求
result = requests.get(url, params=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
result = json.loads(result.content)

# 数据库操作
mysql_handle = mySql()
# 获取conf.ini文件中配置的数据库信息
host, port, user, pwd = mysql_handle.getConf(db="cmdc_db")

# 查询数据库中公司对应的删除标识
sql = "SELECT t.deleteSign  FROM `cmdc-user`.cmdc_jde_config t WHERE configId = {}".format(configId)
result = {"deleteSign": mysql_handle.selectSql(host, port, user, pwd, "cmdc-user", sql)[0][0]}

# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict40")
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
